# 4.Channel exclusive allocation
## 4.1 EB(Transition）


No. |Field Name  |Max.Length|Type|Parameter name|Comment 
 -----|-----|----|----|------|------
  1| Name     |32  |Text|trxn_firstname         |This is name of the customer who is doing the transaction. 
  2| Email     |40  |Text|trxn_email_id         |this is email id of the customer who is doing transaction.
  3|Phone |20  |Text|trxn_phone|Phone number of the customer.
  
## 4.2 UP(Transition）

No. |Field Name  |Max.Length|Type|Parameter name|Comment 
 -----|-----|----|----|------|------
  1| UnionPay card number |19  | Text|uCardNumber |The overseas UnionPay channel is applicable to the UnionPay excellent plan. Can not upload, if you need to fill in the bank card number in advance, then send this field.
  
## 4.3 WX(Includes transition and parameter return）

 No. |Field Name  |Max.Length|Type|Parameter name|Comment 
 -----|-----|----|----|------|------
  1| Transaction scenario code|16  | Text|code |1.“NATIVE“：Return the URL value of WeChat payment collection for parameter return, ask the merchant to convert it into QR code, generate the front interface of payment, and prompt the user to scan the code to pay; 2.“QUICK”：It's jump mode, open the front-end page provided by AllPay, which contains WeChat QR code.

## 4.4 PPRO(Transition）
## 4.4.1 PPRO_AC


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 

Note: AstroPay Card is available for currency USD and country codes BO, BR, CL, CN, CO, CR, MX, PE, UY, VE. 
     
###### 4.4.2 PPRO_AD


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 

Note: AstroPay Direct is available for currency USD and country codes AR, BR, CL, CN, CO, MX, PE, UY. 


###### 4.4.3 PPRO_AR


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Aura (Brazil) is available for currency USD and country code BR. 


###### 4.4.4 PPRO_BA


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Baloto Cash (Colombia) is available for currency USD and country code CO. 


###### 4.4.5 PPRO_BB


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Banco do Brasil (Brazil) is available for currency USD and country code BR. 


###### 4.4.6 PPRO_BO


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Boleto Bancario is available for currency USD and country code BR. 



###### 4.4.7 PPRO_CC


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Cartao MercadoLivre (Brazil) is available for currency USD and country code BR. 

###### 4.4.8 PPRO_DR


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 
phone  |M  |Text |Valid international phone number of the account holder 

Note: Dragonpay is only available for currency PHP and country code PH. 



###### 4.4.9 PPRO_EN


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 
phone  |M  |Text |Valid international phone number of the account holder 

Note: eNETS is only available for currency SGD and country code SG. 

###### 4.4.10 PPRO_EP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

Note: eps only works for the countrycode “AT” and currency “EUR”. 

###### 4.4.11 PPRO_GP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
bic |O  |Text |Valid BIC (8 or 11 alphanumeric letters) of consumer’s bank 


###### 4.4.12 PPRO_HC


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Hipercard (Brazil) is available for currency USD and country code BR. 

###### 4.4.13 PPRO_ID


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

Note: iDEAL only works for the countrycode “NL” and currency “EUR”. 

###### 4.4.14 PPRO_IT


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: Itaú (Brazil) is available for currency USD and country code BR.

###### 4.4.15 PPRO_MB



 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

Note: MyBank only works for the country code IT and currency EUR. 


###### 4.4.16 PPRO_PC



 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 



###### 4.4.17 PPRO_PB



 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 
phone  |M  |Text |Valid international phone number of the account holder 

Note: PAYSBUY Cash is only available for currency THB and country code TH. 



###### 4.4.18 PPRO_PU



 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 

Note: PayU works only for country code/currency combinations CZ/CZK and PL/PLN. 

###### 4.4.19 PPRO_PL


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

Note: POLi only works for the countrycode/currency combinations “NZ”/”NZD” and “AU/AUD”. 

###### 4.4.20 PPRO_P24


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 

Note: Przelewy24 only works for the countrycode “PL” and currencies “PLN” and “EUR”. 


###### 4.4.21 PPRO_QW


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
mobilephone|M   |Text |Valid international Russian mobile phone number identifying the QIWI destination account to pay out to (excluding plus sign or any other international prefixes, including a leading 7 for Russia, 11 digits in total, e.g. 71234567890). 


Note:	QIWI Payout only works for the countrycodes “RU”, “KZ” and UA, and - depending on your contract - currency  “RUB” , “EUR” ,”KZT” and “USD”.  
###### 4.4.22 PPRO_SP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

Note: SafetyPay only works for country codes “AT”, “BR”, “CO”, “CR”, “DE”, “ES”, “MX”, “NI”, “NL”, “PA”, “PE” and currencies “EUR”, “USD”. 

###### 4.4.23 PPRO_SD


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 


Note: SEPA Direct Debit works for all SEPA countries and currency EUR. 


###### 4.4.24 PPRO_SG


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |M   |Text |RFC compliant email address of the account holder 
phone  |M  |Text |Valid international phone number of the account holder 

Note: SingPost (Singapore) is only available for currency SGD and country code SG. 

###### 4.4.25 PPRO_SK


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
email   |O  |Text |RFC compliant email address of the account holder 
address   |O  |Text |Consumer’s address (e.g. street) 
zipcode    |O  |Text |Consumer’s postal code 
city     |O  |Text |Consumer’s city 

###### 4.4.26 PPRO_DP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
bic |O  |Text |Valid BIC (8 or 11 alphanumeric letters) of consumer’s bank 


###### 4.4.27 PPRO_TP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 

TrustPay works for the following country code/currency combinations: 


CZ 
CZK, EUR 


SK 
EUR 


The currencies available to you may depend on your contract. 


###### 4.4.28 PPRO_WP


 Field name  |M/O   |Type |Description  
 -----|-----|----|----
 countrycode|M   |Text |The 2-letter ISO country code of the country in which the payment instrument is issued/operated (e.g. DE). For details see payment method specific documentation. 
accountholdername|M   |Text |The account holder - minimum of 3 characters, up to 100 charac- ters. 
consumerref |M   |Text |Unique reference identifying the consumer, has to satisfy the regular expression [A-Za-z0-9.%,&/+*$-]{1,20} 
nationalid  |M   |Text |Consumer’s national id (up to 30 characters) 
email   |M   |Text |RFC compliant email address of the account holder 
dob    |O   |Text |Date of birth, format YYYYMMDD 

Note: WebPay is available for currency USD and country code CL.