# 3. API接口

## 3.1. 消费交易接口

将相关参数,以表单形式提交到指定 url,即可调起支付。


 序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |消费交易填写“PURC” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|订单金额 |12|文本|orderAmount   |如 100 元，表示为 100 或 100.00 
 6|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 7|前端 URL 地址 |400|文本|frontURL  |支付结果前端通知到该地址 
 8|后端 URL 地址 |400|文本|backURL   |支付结果异步通知到该地址 
 9|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 10|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 11|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 12|支付渠道代码    |10  |文本|paymentSchema|渠道代码：微信：WX, 支付报"APMP",银联 "UP"
 13|商品信息    |60  |文本|goodsInfo       | 商品信息
 14|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 15|签名类型     |3  |文本|signType        |MD5 
 16|签名      |32  |文本|signature         |采用 MD5 签名 

## 3.2. 异步通知报文

 序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |消费交易填写“PURC” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|订单金额 |12|文本|orderAmount   |如 100 元，表示为 100 或 100.00 
 6|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 7|清算金额  |12 |文本|settAmount   |如 100 元，表示为 100 或 100.00  
 8|清算币种  |3|文本|settCurrency    |符合 ISO 标准，填写数字类型 
 9|清算汇率   |7|文本|rate     |实际汇率，7 位有效数字  
 10|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 11|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一
 12|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 13|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 14|支付渠道代码    |10  |文本|paymentSchema|渠道代码：微信：WX, 支付报"APMP",银联 "UP"
 15|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 16|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 17|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 18|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间
 19|签名类型     |3  |文本|signType        |MD5 
 20|签名      |32  |文本|signature         |采用 MD5 签名 


## 3.3. 查询交易接口 



1. 接口说明

 该接口为接入商家提供交易查询的功能。

2. 请求报文格式 

 序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |查询填写“INQY”  
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|商户预留字段  |1024 |文本|merReserve    |商户保留 
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|支付渠道代码    |10  |文本|paymentSchema|渠道代码："WX
 9|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 10|签名类型     |3  |文本|signType        |MD5 
 11|签名      |32  |文本|signature         |采用 MD5 签名 

3. 响应报文格式


  序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |查询交易填写为“INQY 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一  
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 9|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 10|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 11|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 

## 3.4. 退款交易接口

1.接口功能说明 

该接口为接入商家提供交易退款的功能。 

2.请求报文格式 

  序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |退款填写“REFD” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|退款金额  |12|文本|returnAmount    |如 100 元，表示为 100 或 100.00 
 6|订单币种   |3|文本|orderCurrency |人民币填写“CNY”,美元填写"USD" 
 7|商户预留字段  |1024 |文本|merReserve    |商户预留内容，可传任意内容，如购买商品信息、员号等，但不要传特殊符号，如逗号。 
 8|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 9|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 10|支付渠道代码    |10  |文本|paymentSchema|渠道代码："WX
 11|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 

3.响应报文格式

  序号 |名称  |长度|类型|参数名称|备注 
 -----|-----|----|----|------|------
 1|版本号|12|文本|version |统一填写为“VER000000002” 
 2|字符集编码 |6|文本|charSet  |统一填写为“UTF-8” 
 3|交易类型  |4|文本|transType |退款填写“REFD” 
 4|订单号   |60|文本|orderNum  |商户自行定义，需保证同一商户号下订单号不能重复 
 5|GW 交易 ID  |32|文本|transID    |GW 系统生成的交易 ID，每笔交易保持唯一  
 6|商户代码   |15 |文本|merID     |商户 ID，由AllPay 分配 
 7|收单行 ID    |11  |文本|acqID      |收单行 ID "99020344" 
 8|交易应答码   |2  |文本|RespCode       |应答码 00-成功  
 9|应答文字信息    |20  |文本|RespMsg        |应答消息，全部为英文字符 
 10|交易时间    |14  |文本|transTime       |交易时间,格式:"yyyyMMddHHmmss" 
 11|GW 处理时间 |14  |文本|GWTime |YYYYMMDDHHMMSS，为 GW 时间，目前为本地交易时间 
 12|签名类型     |3  |文本|signType        |MD5 
 13|签名      |32  |文本|signature         |采用 MD5 签名 
